#include "core.h"

Core::Core(QObject *parent):
  QObject(parent)
  {
  #ifdef CORE_USE_THREAD
  m_worker=new Thread(this);
  #else
  m_worker=new Worker(this);
  #endif
  connect(m_worker,SIGNAL(result(CustomNumber)),this,SLOT(workerResult(CustomNumber)));
  QTimer::singleShot(0,this,SLOT(run()));
  }

void Core::run(void)
  {
  QTextStream stream(stdout);
  CustomNumber a("a",6);
  CustomNumber b("b",8);

  stream<< "A: " << a.value() << " " << a.string() << "\n";
  stream<< "B: " << b.value() << " " << b.string() << "\n";
  stream.flush();

  m_worker->average(a,b);
  }


void Core::workerResult(const CustomNumber &r)
  {
  QTextStream stream(stdout);

  stream<<"Result value: "<< r.value() << " " << r.string() <<"\n\n";
  stream.flush();

  emit quit();
  }
